package MY;

use strict;
use warnings;
use ExtUtils::MakeMaker;

## NOTE: this breaks the perl "rule" of only using something via it's
## external interface, but MakeMaker's API documentation is screwey
## and user-unfriendly and we are unlikely to upgrade to something
## that doesn't support this syntax anytime soon.

$ExtUtils::MakeMaker::Recognized_Att_Keys{$_}++
    foreach (qw(EXTRA_TARGETS EXTRA_DYNAMIC EXTRA_STATIC));

return 1;

sub build_target {
    my($self, $target, $deps, $build, $force) = @_;
    my @rv = ("\n\n");
    if($force) {
        push(@rv, qq{$target :: });
    } else {
        push(@rv, qq{$target : });
    }
    
    if(UNIVERSAL::isa($deps, "ARRAY")) {
        push(@rv, join(' ', @$deps));
    } elsif($deps) {
        push(@rv, $deps);
    }
    
    push(@rv, "\n");
    
    if(UNIVERSAL::isa($build, "ARRAY")) {
        push(@rv, join("\n", map { "\t$_" } @$build));
    } elsif($build) {
        push(@rv, "\t$build\n");
    }
    
    push(@rv, "\n\n");
    
    return join('', @rv);
}


sub add_target_deps {
    my($self, $target, $deps) = @_;
    return $target unless($deps);
    my $s_deps = UNIVERSAL::isa($deps, "ARRAY") ? join(" ", @$deps) : $deps;
    $target =~ s{^(\w+\s*\:{1,2}[ \t]*)}{$1$s_deps }m;
    return $target;
}


sub dynamic {
    my $self = shift;
    my $target = $self->SUPER::dynamic(@_);
    if($self->{EXTRA_DYNAMIC}) {
        $target = MY->add_target_deps($target, $self->{EXTRA_DYNAMIC});
    }
    return $target;
}

sub static {
    my $self = shift;
    my $target = $self->SUPER::dynamic;
    if($self->{EXTRA_STATIC}) {
        $target = MY->add_target_deps($target, $self->{EXTRA_STATIC});
    }
    return $target; 
}

sub postamble {
    my $self = shift;
    my(@rv) = ($self->SUPER::postamble);
    if(UNIVERSAL::isa($self->{EXTRA_TARGETS}, "HASH")) {
        while(my($k, $v) = each(%{$self->{EXTRA_TARGETS}})) {
            push(@rv, MY->build_target($k, @$v));
        }
    } elsif(UNIVERSAL::isa($self->{EXTRA_TARGETS}, "ARRAY")) {
        push(@rv, MY->build_target(@{$self->{EXTRA_TARGETS}}));
    } elsif($self->{EXTRA_TARGETS}) {
        die "Malformed TARGETS line in Makefile.PL";
    }
    join('', @rv);
}

1;
